{-| Module      : Graph.Tools.Clean
Description :
Copyright   : (c) CNRS, GarganText, Alexandre Delanoë
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX

-}

{-# LANGUAGE ConstraintKinds #-}
{-# LANGUAGE InstanceSigs    #-}
{-# LANGUAGE NoImplicitPrelude       #-}


module Graph.Tools.Clean where

import Data.Vector hiding (map, uniq)
import Prelude (read)
import Protolude
import qualified Eigen.SparseMatrix as SMatrix
import qualified Data.Map                          as Map
import qualified Data.Graph.Inductive              as DGI
import qualified Data.Set                          as Set

------------------------------------------------------------------------
-- | Clean tools
uniq :: [DGI.Edge] -> [DGI.Edge]
uniq ns = Set.toList
        $ Set.fromList
        $ map (\(n1,n2)
                -> if n1 <= n2
                      then (n1,n2)
                      else (n2,n1)
              ) ns


uniq' :: [(Int,Int,Double)] -> [(Int,Int,Double)]
uniq' ns = map (\(n1,n2) -> (n1,n2,1))
         $ Map.keys
         $ Map.fromListWith (+)
         $ map (\(n1,n2,w)
                  -> if n1 <= n2
                        then ((n1,n2), w)
                        else ((n2,n1), w)
                ) ns

